

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Xlib.Structs.XWindowAttributes
    ( 

-- * Exported types
    XWindowAttributes(..)                   ,
    noXWindowAttributes                     ,


    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL


-- | Memory-managed wrapper type.
newtype XWindowAttributes = XWindowAttributes (ManagedPtr XWindowAttributes)
-- XXX Wrapping a foreign struct/union with no known destructor or size, leak?
instance WrappedPtr XWindowAttributes where
    wrappedPtrCalloc = return nullPtr
    wrappedPtrCopy = return
    wrappedPtrFree = Nothing

-- | A convenience alias for `Nothing` :: `Maybe` `XWindowAttributes`.
noXWindowAttributes :: Maybe XWindowAttributes
noXWindowAttributes = Nothing


#if ENABLE_OVERLOADING
instance O.HasAttributeList XWindowAttributes
type instance O.AttributeList XWindowAttributes = XWindowAttributesAttributeList
type XWindowAttributesAttributeList = ('[ ] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
type family ResolveXWindowAttributesMethod (t :: Symbol) (o :: *) :: * where
    ResolveXWindowAttributesMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveXWindowAttributesMethod t XWindowAttributes, O.MethodInfo info XWindowAttributes p) => OL.IsLabel t (XWindowAttributes -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif


